module adler32 (
	input logic clk,
	input logic rst,
	input logic data_valid,
	input logic last_data,
	input logic [255:0] data_in,
	output logic [31:0] sum, // sum[31:16] = s2, sum[15:0] = s1
	output logic sum_valid
);

// s1 is the sum of all bytes
// s2 is the sum of all s1 values
logic [15:0] s2,s1_0, s1_1, s1_2, s1_3, s1_4, s1_5, s1_6, s1_7, s1_8, s1_9, s1_10, s1_11, s1_12, s1_13, s1_14, s1_15, s1_16, s1_17, s1_18, s1_19, s1_20, s1_21, s1_22, s1_23, s1_24, s1_25, s1_26, s1_27, s1_28, s1_29, s1_30, s1_31;
assign sum[31:16] = s2;
assign sum[15:0] = s1_31;



always @(posedge clk or posedge rst)
begin
	if (rst)
	begin
		s1_0 <= 16'd1;
		s2 <= 16'd0;
		sum_valid <= 1'b0;
	end
	if (data_valid)
	begin
		if (last_data)
			sum_valid <= 1'b1;
		// data_in contains 32 bytes
		s1_1 = s1_0 + data_in[255-8*1:256-8*2];
		if (s1_1 > 65521)
			s1_1 = s1_1 % 65535;
		s1_2 = s1_1 + data_in[255-8*2:256-8*3];
		if (s1_2 > 65521)
			s1_2 = s1_2 % 65535;
		s1_3 = s1_2 + data_in[255-8*3:256-8*4];
		if (s1_3 > 65521)
			s1_3 = s1_3 % 65535;
		s1_4 = s1_3 + data_in[255-8*4:256-8*5];
		if (s1_4 > 65521)
			s1_4 = s1_4 % 65535;
		s1_5 = s1_4 + data_in[255-8*5:256-8*6];
		if (s1_5 > 65521)
			s1_5 = s1_5 % 65535;
		s1_6 = s1_5 + data_in[255-8*6:256-8*7];
		if (s1_6 > 65521)
			s1_6 = s1_6 % 65535;
		s1_7 = s1_6 + data_in[255-8*7:256-8*8];
		if (s1_7 > 65521)
			s1_7 = s1_7 % 65535;
		s1_8 = s1_7 + data_in[255-8*8:256-8*9];
		if (s1_8 > 65521)
			s1_8 = s1_8 % 65535;
		s1_9 = s1_8 + data_in[255-8*9:256-8*10];
		if (s1_9 > 65521)
			s1_9 = s1_9 % 65535;
		s1_10 = s1_9 + data_in[255-8*10:256-8*11];
		if (s1_10 > 65521)
			s1_10 = s1_10 % 65535;
		s1_11 = s1_10 + data_in[255-8*11:256-8*12];
		if (s1_11 > 65521)
			s1_11 = s1_11 % 65535;
		s1_12 = s1_11 + data_in[255-8*12:256-8*13];
		if (s1_12 > 65521)
			s1_12 = s1_12 % 65535;
		s1_13 = s1_12 + data_in[255-8*13:256-8*14];
		if (s1_13 > 65521)
			s1_13 = s1_13 % 65535;
		s1_14 = s1_13 + data_in[255-8*14:256-8*15];
		if (s1_14 > 65521)
			s1_14 = s1_14 % 65535;
		s1_15 = s1_14 + data_in[255-8*15:256-8*16];
		if (s1_15 > 65521)
			s1_15 = s1_15 % 65535;
		s1_16 = s1_15 + data_in[255-8*16:256-8*17];
		if (s1_16 > 65521)
			s1_16 = s1_16 % 65535;
		s1_17 = s1_16 + data_in[255-8*17:256-8*18];
		if (s1_17 > 65521)
			s1_17 = s1_17 % 65535;
		s1_18 = s1_17 + data_in[255-8*18:256-8*19];
		if (s1_18 > 65521)
			s1_18 = s1_18 % 65535;
		s1_19 = s1_18 + data_in[255-8*19:256-8*20];
		if (s1_19 > 65521)
			s1_19 = s1_19 % 65535;
		s1_20 = s1_19 + data_in[255-8*20:256-8*21];
		if (s1_20 > 65521)
			s1_20 = s1_20 % 65535;
		s1_21 = s1_20 + data_in[255-8*21:256-8*22];
		if (s1_21 > 65521)
			s1_21 = s1_21 % 65535;
		s1_22 = s1_21 + data_in[255-8*22:256-8*23];
		if (s1_22 > 65521)
			s1_22 = s1_22 % 65535;
		s1_23 = s1_22 + data_in[255-8*23:256-8*24];
		if (s1_23 > 65521)
			s1_23 = s1_23 % 65535;
		s1_24 = s1_23 + data_in[255-8*24:256-8*25];
		if (s1_24 > 65521)
			s1_24 = s1_24 % 65535;
		s1_25 = s1_24 + data_in[255-8*25:256-8*26];
		if (s1_25 > 65521)
			s1_25 = s1_25 % 65535;
		s1_26 = s1_25 + data_in[255-8*26:256-8*27];
		if (s1_26 > 65521)
			s1_26 = s1_26 % 65535;
		s1_27 = s1_26 + data_in[255-8*27:256-8*28];
		if (s1_27 > 65521)
			s1_27 = s1_27 % 65535;
		s1_28 = s1_27 + data_in[255-8*28:256-8*29];
		if (s1_28 > 65521)
			s1_28 = s1_28 % 65535;
		s1_29 = s1_28 + data_in[255-8*29:256-8*30];
		if (s1_29 > 65521)
			s1_29 = s1_29 % 65535;
		s1_30 = s1_29 + data_in[255-8*30:256-8*31];
		if (s1_30 > 65521)
			s1_30 = s1_30 % 65535;
		s1_31 = s1_30 + data_in[255-8*31:256-8*32];
		if (s1_31 > 65521)
			s1_31 = s1_31 % 65535;
		s2 = s2+ s1_0+ s1_1+ s1_2+ s1_3+ s1_4+ s1_5+ s1_6+ s1_7+ s1_8+ s1_9+ s1_10+ s1_11+ s1_12+ s1_13+ s1_14+ s1_15+ s1_16+ s1_17+ s1_18+ s1_19+ s1_20+ s1_21+ s1_22+ s1_23+ s1_24+ s1_25+ s1_26+ s1_27+ s1_28+ s1_29+ s1_30+ s1_31;
		if (s2 > 65521)
			s2 = s2 % 65535;
	end
end


endmodule
